# Find the final_dims_fake for metadata if it needs to be reshaped
find_final_dims_fake_metadata <- function(merge_across_dims, split_multiselected_dims, 
                                          picked_common_vars, across_inner_dim, final_dims_fake, 
                                          dims_of_merge_dim, all_split_dims, inner_dim_has_split_dim) {
  if (merge_across_dims) {
    if (!split_multiselected_dims) {
      final_dims_fake_metadata <- final_dims_fake[names(final_dims_fake) %in% names(dims_of_merge_dim)]
    } else {
      final_dims_fake_metadata <- final_dims_fake[names(final_dims_fake) %in% names(all_split_dims[[across_inner_dim]])]
    }
  } else if (split_multiselected_dims) {
    if (!identical(inner_dim_has_split_dim, character(0))) {
      target_split_dim_ind <- which(names(dim(picked_common_vars[[inner_dim_has_split_dim]])) == names(all_split_dims))
      margin_dim_ind <- c(1:length(dim(picked_common_vars[[inner_dim_has_split_dim]])))[-target_split_dim_ind]
      if (identical(margin_dim_ind, numeric(0)) | identical(margin_dim_ind, integer(0))) {
        final_dims_fake_metadata <- all_split_dims[[1]]
      } else {
        final_dims_fake_metadata <- .ReplaceElementInVector(dim(picked_common_vars[[inner_dim_has_split_dim]]), target = names(all_split_dims), new_val = all_split_dims[[1]])
      }
    }
  }
  return(final_dims_fake_metadata)
}
