
exp <- 'a3w5'
vari <- 'tas'
mod <- 'Amon'
grid <- '1x1'
#NOTE: era5 from 197901 to 202006
yr1 <- '1979'
yr2 <- '2018'
t1 <- 1
t2 <- 60 
chosen_season <- 'Annual' #'DJF'
lats <- c(-90, 90)
lons <- c(0, 359.9)
#PROBLEM: a3w5 should have i4, not i1; but grid '1x1' is only under i1
membs <- c('r1i1p1f1','r2i1p1f1','r3i1p1f1','r4i1p1f1','r5i1p1f1','r6i1p1f1','r7i1p1f1','r8i1p1f1','r9i1p1f1','r10i1p1f1')
nmemb <- length(membs)

#--------------------------
# Step1: Load CMIP6 DCPP
#--------------------------

repos <- paste0('/esarchive/exp/ecearth/', exp, '/diags/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/$memb$/',
                mod, '/$var$/', grid, '/v*/$var$_', mod,
                '_EC-Earth3_dcppA-hindcast_s$sdate$1101-$memb$_', grid,
                '_$chunk$.nc')

data <- Start(dat = repos,
              var = vari,
              memb = membs,
              sdate = paste(seq(yr1, yr2)),
              chunk = 'all',
              chunk_depends = 'sdate',
              time = c(t1:t2), #'all',
              time_across = 'chunk',
              merge_across_dims = TRUE,
              latitude = values(list(lats[1], lats[2])),
              longitude = values(list(lons[1], lons[2])),
#              latitude = 'all',
              latitude_reorder = Sort(),
#              longitude = 'all',
              longitude_reorder = CircularSort(0, 360),
              synonims = list(longitude = c('lon', 'longitude'),
                              latitude = c('lat', 'latitude')),
#              transform = CDORemapper, transform_extra_cells = 2, transform_params = list(grid = 'r360x180', method = 'con', crop = FALSE), transform_vars = c('lat','lon'),
              return_vars = list(time = c('sdate', 'chunk'),
                                 latitude = NULL, longitude = NULL),
              retrieve = F)
attr(data, 'Dimensions')


#--------------------------
# Step3: Load obs
#--------------------------
obs <- 'era5'
path_obs <- paste0('/esarchive/recon/ecmwf/', obs, '/monthly_mean/$var$_f1h-r360x180/$var$_$file_date$.nc')
time_data <- attr(data, 'Variables')$common$time #[sdate, time]
data_obs <- Start(dat = path_obs,
              var = vari,
              file_date = unique(format(time_data, '%Y%m')), #paste(seq(yr1, yr2)),
              time = values(time_data),
              time_across = 'file_date',
              merge_across_dims = TRUE,
              split_multiselected_dims = TRUE,
              latitude = values(list(lats[1], lats[2])),
              longitude = values(list(lons[1], lons[2])),
              latitude_reorder = Sort(),
              longitude_reorder = CircularSort(0, 360),
              synonims = list(longitude = c('lon', 'longitude'),
                              latitude = c('lat', 'latitude')),
              return_vars = list(time = c('file_date'),
                                 latitude = NULL, longitude = NULL),
              retrieve = F)
attr(data_obs, 'Dimensions')
